﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace DoubleDeckerBus
{
    internal class DrawingDDB : DrawingBus
    {
        public DrawingDDB(int speed, float weight, Color bodyColor, Color extraColor, bool ledder, bool secondStage) : base(speed, weight, bodyColor, 100, 100) {
            Bus = new EntityDDB(speed, weight, bodyColor, extraColor, ledder, secondStage);
        }

        public override void DrawTransport(Graphics g)
        {
            if (Bus is not EntityDDB doubleDeckerBus)
            {
                return;
            }

            Pen pen = new(Color.Black);
            Brush extraBrush = new SolidBrush(doubleDeckerBus.ExtraColor);

            if (doubleDeckerBus.SecondStage) {
                g.FillRectangle(extraBrush, _startPosX, _startPosY + 10, 100, 30);

                g.DrawRectangle(pen, _startPosX + 30, _startPosY + 20, 10, 20);
                Brush brBlack = new SolidBrush(Color.Black);
                g.FillRectangle(brBlack, _startPosX + 30, _startPosY + 20, 10, 20);


                Brush brBlue = new SolidBrush(Color.Blue);
                g.FillEllipse(brBlue, _startPosX + 10, _startPosY + 15, 10, 15);
                g.FillEllipse(brBlue, _startPosX + 50, _startPosY + 15, 10, 15);
                g.FillEllipse(brBlue, _startPosX + 70, _startPosY + 15, 10, 15);
                g.FillEllipse(brBlue, _startPosX + 90, _startPosY + 15, 10, 15);
            }

            _startPosY += 30;
            base.DrawTransport(g);
            _startPosY -= 30;

            if (doubleDeckerBus.Ledder) {
                //Вертикальные прямые
                g.DrawLine(pen, new Point((int)(_startPosX), (int)(_startPosY + 70)), new Point((int)(_startPosX), (int)(_startPosY + 10)));
                g.DrawLine(pen, new Point((int)(_startPosX + 10), (int)(_startPosY + 70)), new Point((int)(_startPosX + 10), (int)(_startPosY + 10)));

                //Горизонтальные прямые
                g.DrawLine(pen, new Point((int)(_startPosX), (int)(_startPosY + 20)), new Point((int)(_startPosX + 10), (int)(_startPosY + 20)));
                g.DrawLine(pen, new Point((int)(_startPosX), (int)(_startPosY + 30)), new Point((int)(_startPosX + 10), (int)(_startPosY + 30)));
                g.DrawLine(pen, new Point((int)(_startPosX), (int)(_startPosY + 40)), new Point((int)(_startPosX + 10), (int)(_startPosY + 40)));
                g.DrawLine(pen, new Point((int)(_startPosX), (int)(_startPosY + 50)), new Point((int)(_startPosX + 10), (int)(_startPosY + 50)));
                g.DrawLine(pen, new Point((int)(_startPosX), (int)(_startPosY + 60)), new Point((int)(_startPosX + 10), (int)(_startPosY + 60)));
            }
        }
    }
}
