namespace DoubleDeckerBus
{
    public partial class FormBus : Form
    {
        private DrawingBus _bus;
        public FormBus()
        {
            InitializeComponent();
        }

        private void Draw()
        {
            Bitmap bmp = new(pictureBoxBus.Width, pictureBoxBus.Height);
            Graphics gr = Graphics.FromImage(bmp);
            _bus?.DrawTransport(gr);
            pictureBoxBus.Image = bmp;
        }

        private void ButtonCreate_Click(object sender, EventArgs e)
        {
            Random rnd = new();
            _bus = new DrawingBus(rnd.Next(100, 300), rnd.Next(1000, 2000), Color.FromArgb(rnd.Next(0, 256), rnd.Next(0, 256), rnd.Next(0, 256)));
            SetData();
            Draw();
        }

        private void ButtonMove_Click(object sender, EventArgs e) {
            string name = ((Button)sender)?.Name ?? string.Empty;
            switch (name)
            {
                case "buttonUp":
                    _bus?.MoveTransport(Direction.Up);
                    break;
                case "buttonDown":
                    _bus?.MoveTransport(Direction.Down);
                    break;
                case "buttonLeft":
                    _bus?.MoveTransport(Direction.Left);
                    break;
                case "buttonRight":
                    _bus?.MoveTransport(Direction.Right);
                    break;
            }
            Draw();
        }

        public void SetData() {
            Random rnd = new();
            _bus.SetPosition(rnd.Next(10, 100), rnd.Next(10, 100), pictureBoxBus.Width, pictureBoxBus.Height);
            toolStripStatusLabelSpeed.Text = $": {_bus.Bus.Speed}";
            toolStripStatusLabelWeight.Text = $": {_bus.Bus.Weight}";
            toolStripStatusLabelBodyColor.Text = $": {_bus.Bus.BodyColor.Name}";
        }

        private void PictureBoxBus_Resize(object sender, EventArgs e) {
            _bus?.ChangeBorders(pictureBoxBus.Width, pictureBoxBus.Height);
            Draw();
        }

        private void ButtonreateExtra_Click(object sender, EventArgs e)
        {
            Random rnd = new();
            _bus = new DrawingDDB(rnd.Next(100, 300), rnd.Next(1000, 2000),
                Color.FromArgb(rnd.Next(0, 256), rnd.Next(0, 256), rnd.Next(0, 256)),
                Color.FromArgb(rnd.Next(0, 256), rnd.Next(0, 256), rnd.Next(0, 256)),
                Convert.ToBoolean(rnd.Next(0, 2)), Convert.ToBoolean(rnd.Next(0, 2)));
            SetData();
            Draw();
        }
    }
}